{
===============================================================================
  Copyright (©) 2001. Rodax Software.
===============================================================================
  Los contenidos de este fichero son propiedad de Rodax Software titular del
  copyright. Este fichero sólo podrá ser copiado, distribuido y utilizado,
  en su totalidad o en parte, con el permiso escrito de Rodax Software, o de
  acuerdo con los términos y condiciones establecidas en el acuerdo/contrato
  bajo el que se suministra.
  -----------------------------------------------------------------------------
  Web:  www.rodax-software.com
===============================================================================
  Fecha primera versión: 01-10-2001
  Versión actual: 1.0.6
  Fecha versión actual: 28-06-2004
===============================================================================
  Modificaciones:

    Fecha         Comentarios
    ---------------------------------------------------------------------------
    25-10-2001    El orden de las columnas es:
                      - Codigo factura
                      - Fecha de alta
                      - Cliente
                      - Importe total
                      - Fecha vto.
                      - Situación

    26-01-2002    Se ha rediseñado el informe para usar Word directamente en
                  vez de exportación a RTF. Ahora el informe se agrupa por
                  meses.

    05-03-2002    El informe ahora saca el listado por intervalo de fechas
                  de facturas.

    07-04-2002    Se ha adaptado para la transacción única.

    05-08-2002    p234. En el informe de facturas pendientes de cliente no
                  deben aparecer las que estén pagadas.

    28-06-2004    p272. Adaptación a multiempresa.

    28-06-2004    p274. Migración a FastReport.                     
===============================================================================
}

unit InformeListadoFacturasCliIVA;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  InformeBase, IBDatabase, Db, FR_IBXDB, FR_Shape, FR_Class, FR_DSet,
  FR_DBSet, IBCustomDataSet, IBQuery;

type
  TdmInformeListadoFacturasCliIVA = class(TdmInformeBase)
    TablaFacturas: TIBQuery;
    frdsTablaFacturas: TfrDBDataSet;
  private
    FFechaIni: Variant;
    FFechaFin: Variant;
    procedure InformeGetParametersText(Memo : TStringList);
  protected
    procedure PrepararConsultas; override;
  public
    constructor Create(AOwner: TComponent); override;
  published
    property FechaIni : Variant read FFechaIni write FFechaIni;
    property FechaFin : Variant read FFechaFin write FFechaFin;
  end;

var
  dmInformeListadoFacturasCliIVA: TdmInformeListadoFacturasCliIVA;

implementation

{$R *.DFM}

{ TdmInformeListadoFacturasCliIVA }

uses
  RdxEmpresaActiva, Literales;

constructor TdmInformeListadoFacturasCliIVA.Create(
  AOwner: TComponent);
begin
  inherited;
  FFechaIni := NULL;
  FFechaFin := NULL;
  FNombreInforme := 'ListadoFacturasCliIVA.frf';
  OnGetParametersText := InformeGetParametersText;
end;

procedure TdmInformeListadoFacturasCliIVA.InformeGetParametersText(
  Memo: TStringList);
begin
  with Memo do
    Add(SysUtils.Format(msgInfIntervaloFec, [FFechaIni, FFechaFin]))
end;

procedure TdmInformeListadoFacturasCliIVA.PrepararConsultas;
begin
  with TablaFacturas do
  begin
    Database := FBaseDatos;
    Transaction := FTransaccion;
    SQL.Clear;
    SQL.Add('select NOMBRE, CODIGO, FECHAALTA, NIFCIF, ');
    SQL.Add('IMPORTEIVA, IMPORTETOTAL, (BASEIMPONIBLE-IMPORTEDESCUENTO) AS BASEIMPONIBLE,');
    SQL.Add('EXTRACT (MONTH FROM FECHAALTA)||''/''||EXTRACT (YEAR FROM FECHAALTA) as MES ');
    SQL.Add('from FACTURASCLIENTE ');
    SQL.Add('where FECHAALTA between :FECHAINI and :FECHAFIN ');
    SQL.Add('and CODIGOEMPRESA = :CODIGOEMPRESA ');
    SQL.Add('order by FECHAALTA, NOMBRE, CODIGO');

    ParamByName('FECHAINI').AsDate := FFechaIni;
    ParamByName('FECHAFIN').AsDate := FFechaFin;
    ParambyName('CODIGOEMPRESA').AsInteger := EmpresaActiva.Codigo;
    Prepare;
  end;
end;

end.
